/***
 * Excerpted from "Domain-Driven Design Using Naked Objects",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/dhnako for more book information.
***/
public Person me() {
    return firstMatch(Person.class, new Filter<Person>() {
        final String currentUserId = 
            getContainer().getUser().getName();
        public boolean accept(final Person person) {
            Employee employee = person.getRole(Employee.class);
            return employee != null && 
                   employee.getUserId().equals(currentUserId);
        }});
}
